data.raw.lamp["small-lamp"].fast_replaceable_group = "lamp"
-- data.raw.lamp["small-lamp"].collision_box = {{-0.40, -0.40}, {0.40, 0.40}}
local black_entity = table.deepcopy(data.raw.lamp["small-lamp"])
data.raw.lamp["small-lamp"].next_upgrade = "black-flip-dot"

black_entity.name = "black-flip-dot"
black_entity.minable.result = "black-flip-dot"
black_entity.darkness_for_all_lamps_on = 1.0
black_entity.darkness_for_all_lamps_off = 1.0
black_entity.light.intensity = 0.0
black_entity.light_when_colored.intensity = 0.0
black_entity.glow_size = 0
black_entity.next_upgrade = "small-lamp"
black_entity.collision_box = {{-0.49, -0.49}, {0.49, 0.49}} -- data.raw["lamp"]["small-lamp"].collision_box
black_entity.selection_box = {{-0.50, -1.0}, {0.50, 0.50}} -- data.raw["lamp"]["small-lamp"].selection_box
black_entity.collision_box = data.raw["lamp"]["small-lamp"].collision_box

black_entity.picture_off =
{
  layers =
  {
    {
      filename = "__flip-dots__/box.png",
      priority = "high",
      width = 64,
      height = 64,
      frame_count = 1,
      axially_symmetrical = false,
      direction_count = 1,
      shift = util.by_pixel(8,-8),
      hr_version =
      {
        filename = "__flip-dots__/hr-box.png",
        priority = "high",
        width = 128,
        height = 128,
        frame_count = 1,
        axially_symmetrical = false,
        direction_count = 1,
        shift = util.by_pixel(8,-8),
        scale = 0.5
      }
    },
    {
      filename = "__flip-dots__/shadow.png",
      priority = "high",
      width = 64,
      height = 64,
      frame_count = 1,
      axially_symmetrical = false,
      direction_count = 1,
      shift = util.by_pixel(8,-8),
      draw_as_shadow = true,
      hr_version =
      {
        filename = "__flip-dots__/hr-shadow.png",
        priority = "high",
        width = 128,
        height = 128,
        frame_count = 1,
        axially_symmetrical = false,
        direction_count = 1,
        shift = util.by_pixel(8,-8),
        draw_as_shadow = true,
        scale = 0.5
      }
    }
  }
}

black_entity.picture_on =
{
  filename = "__flip-dots__/dot.png",
  priority = "high",
  width = 64,
  height = 64,
  frame_count = 1,
  axially_symmetrical = false,
  direction_count = 1,
  shift = util.by_pixel(8,-8),
  hr_version =
  {
    filename = "__flip-dots__/hr-dot.png",
    priority = "high",
    width = 128,
    height = 128,
    frame_count = 1,
    axially_symmetrical = false,
    direction_count = 1,
    shift = util.by_pixel(8,-8),
    scale = 0.5
  }
}

black_entity.signal_to_color_mapping =
{
  {type = "virtual", name = "signal-red",    color = {r = 1, g = 0.1, b = 0.0}},
  {type = "virtual", name = "signal-green",  color = {r = 0.2, g = 1, b = 0.0}},
  {type = "virtual", name = "signal-blue",   color = {r = 0.0, g = 0.5, b = 1}},
  {type = "virtual", name = "signal-yellow", color = {r = 1, g = 1, b = 0.0}},
  {type = "virtual", name = "signal-pink",   color = {r = 1, g = 0.0, b = 0.5}},
  {type = "virtual", name = "signal-cyan",   color = {r = 0.0, g = 1, b = 0.5}},
  {type = "virtual", name = "signal-white",  color = {r = 1, g = 1, b = 1}},
  {type = "virtual", name = "signal-grey",   color = {r = 0.4, g = 0.5, b = 0.6}},
  {type = "virtual", name = "signal-black",  color = {r = 1.0, g = 0.5, b = 0.0}},
}

-- black_entity.circuit_connector_sprites = nil
-- black_entity.circuit_wire_connection_point.wire.red = {0.35, 0.5}
-- black_entity.circuit_wire_connection_point.wire.green = {0.40, 0.5}
-- black_entity.circuit_wire_connection_point.shadow.red = {0.37, 0.52}
-- black_entity.circuit_wire_connection_point.shadow.green = {0.42, 0.52}

black_entity.icon = "__flip-dots__/lamp-icon.png"
black_entity.icon_size = 64

local black_item = table.deepcopy(data.raw["item"]["small-lamp"])

black_item.name = "black-flip-dot"
black_item.icon = "__flip-dots__/lamp-icon.png"
black_item.icon_size = 64
black_item.order = "a[light]-a[small-lamp]_a"
black_item.place_result = "black-flip-dot"
black_item.stack_size = 50


local black_recipe = table.deepcopy(data.raw["recipe"]["small-lamp"])

black_recipe.enabled = true
black_recipe.name = "black-flip-dot"
black_recipe.ingredients = {{"wooden-chest", 1}, {"electric-engine-unit", 1}, {"coal", 1}, {"small-lamp", 1}}
black_recipe.result = "black-flip-dot"

data:extend{black_entity, black_item, black_recipe}
