local util = require("util")

data.raw.lamp["small-lamp"].fast_replaceable_group = "lamp"
-- data.raw.lamp["small-lamp"].collision_box = {{-0.40, -0.40}, {0.40, 0.40}}
local switch_entity = table.deepcopy(data.raw["power-switch"]["power-switch"])

data.raw.lamp["small-lamp"].next_upgrade = "switch-flip-dot"
data.raw.lamp["black-flip-dot"].next_upgrade = "switch-flip-dot"

switch_entity.fast_replaceable_group = "lamp"
switch_entity.name = "switch-flip-dot"
switch_entity.minable.result = "switch-flip-dot"
switch_entity.collision_box = {{-0.49, -0.49}, {0.49, 0.49}} -- data.raw["lamp"]["small-lamp"].collision_box
switch_entity.selection_box = {{-0.50, -1.0}, {0.50, 0.50}} -- data.raw["lamp"]["small-lamp"].selection_box
switch_entity.collision_box = data.raw["lamp"]["small-lamp"].collision_box

-- the game seems to ignore circuit_connector_sprites
-- switch_entity.circuit_connector_sprites = data.raw["lamp"]["small-lamp"].circuit_connector_sprites


-- switch_entity.circuit_wire_connection_point = data.raw["lamp"]["small-lamp"].circuit_wire_connection_point

-- switch_entity.circuit_connector_sprites = table.deepcopy(data.raw["lamp"]["small-lamp"].circuit_connector_sprites)
-- switch_entity.circuit_wire_connection_point = table.deepcopy(data.raw["lamp"]["small-lamp"].circuit_wire_connection_point)


switch_entity.circuit_wire_connection_point =
{
  wire = {
    red = {
      x = 0.36, y = -0.2
    },
    green = {
      x = 0.36, y = -0.2
    }
  },
  shadow = {
    red = {
      x = 0.86, y = 0.3
    },
    green = {
      x = 0.86, y = 0.3
    }
  }
}

switch_entity.led_on = util.draw_as_glow
    {
      filename = "__base__/graphics/entity/power-switch/power-switch-led.png",
      x = 0,
      width = 1,
      height = 1,
      shift = util.by_pixel(0, 0),
      blend_mode = "additive",
      hr_version =
      {
        filename = "__base__/graphics/entity/power-switch/hr-power-switch-led.png",
        x = 0,
        width = 1,
        height = 1,
        shift = util.by_pixel(0, 0),
        blend_mode = "additive",
        scale = 0.5
      }
    }

switch_entity.led_off = util.draw_as_glow
    {
      filename = "__base__/graphics/entity/power-switch/power-switch-led.png",
      x = 0,
      width = 1,
      height = 1,
      shift = util.by_pixel(0, 0),
      blend_mode = "additive",
      hr_version =
      {
        filename = "__base__/graphics/entity/power-switch/hr-power-switch-led.png",
        x = 0,
        width = 1,
        height = 1,
        shift = util.by_pixel(0, 0),
        blend_mode = "additive",
        scale = 0.5
      }
    }


-- switch_entity.draw_circuit_wires = 0

-- switch_entity.working_sound.deactivate_sound = table.deepcopy(switch_entity.working_sound.activate_sound)

switch_entity.working_sound.audible_distance_modifier = 0.5
switch_entity.working_sound.max_sounds_per_type = 3

switch_entity.working_sound.deactivate_sound = switch_entity.working_sound.activate_sound
switch_entity.corpse = data.raw["power-switch"]["power-switch"].corpse


switch_entity.power_on_animation =
{
  layers = {
    {
      filename = "__flip-dots__/animation.png",
      animation_speed = 1,
      line_length = 3,
      width = 64,
      height = 64,
      frame_count = 9,
      shift = util.by_pixel(8, -8),
      hr_version =
      {
        filename = "__flip-dots__/hr-animation.png",
        animation_speed = 1,
        line_length = 3,
        width = 128,
        height = 128,
        frame_count = 9,
        shift = util.by_pixel(8, -8),
        scale = 0.5
      }
    },
    {
      filename = "__flip-dots__/anishadow.png",
      animation_speed = 1,
      line_length = 3,
      width = 64,
      height = 64,
      frame_count = 9,
      shift = util.by_pixel(8, -8),
      draw_as_shadow = true,
      hr_version =
      {
        filename = "__flip-dots__/hr-anishadow.png",
        animation_speed = 1,
        line_length = 3,
        width = 128,
        height = 128,
        frame_count = 9,
        shift = util.by_pixel(8, -8),
        draw_as_shadow = true,
        scale = 0.5
      }
    }
  }
}

switch_entity.icon = "__flip-dots__/switch-icon.png"
switch_entity.icon_size = 64

local switch_item = table.deepcopy(data.raw["item"]["small-lamp"])

switch_item.name = "switch-flip-dot"
switch_item.icon = "__flip-dots__/switch-icon.png"
switch_item.icon_size = 64
switch_item.order = "a[light]-a[small-lamp]_b"
switch_item.place_result = "switch-flip-dot"
switch_item.stack_size = 50

local switch_recipe = table.deepcopy(data.raw["recipe"]["power-switch"])

switch_recipe.enabled = true
switch_recipe.name = "switch-flip-dot"
switch_recipe.ingredients = {{"wooden-chest", 1}, {"electric-engine-unit", 1}, {"coal", 1}, {"sulfur", 1}}
switch_recipe.result = "switch-flip-dot"

data:extend{switch_entity, switch_item, switch_recipe}
